<!DOCTYPE html>
<html class="wf-liberationsans-n4-active wf-ptsanscaption-n4-active wf-active"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta charset="utf-8">
    <title>conllu.js</title>
    <meta name="viewport" content="width=device-width">
    <meta name="description" content="CoNLL-U format library for JavaScript">

    <link rel="stylesheet" href="conllu.js_files/jquery-ui-redmond.css">
    <link rel="stylesheet" href="conllu.js_files/main.css">
    <link rel="stylesheet" href="conllu.js_files/style-vis.css">

    <script type="text/javascript" src="conllu.js_files/head.js"></script><link rel="stylesheet" href="conllu.js_files/PT_Sans-Caption-Web-Regular.ttf"><link rel="stylesheet" href="conllu.js_files/Liberation_Sans-Regular.ttf">
<style type="text/css">/* This is not a zero-length file! */</style><style type="text/css">/* This is not a zero-length file! */</style></head>

<body>
  
  <header class="site-header">      
    <div class="wrap">
      <a class="topnav" href="https://github.com/spyysalo/conllu.js">conllu.js</a>
    </div>
  </header>

  <div class="page-content">
    <div class="wrap">
      <div class="entry">

	<header class="entry-header">
	  <h1>conllu.js: CoNLL-U format library for JavaScript</h1>
	</header>

<article class="entry-content">

<p>This is a placeholder for conllu.js library documentation,
hopefully to follow soon.</p>

<p>For the time being, here is an example editable visualization
generated from CoNLL-U formatted input that illustrates support for
two "structured comments", <code>visual-style</code> and 
<code>sentence-label</code>.</p>

<code class="conllu-parse embedding embedded-wrapper" tabs="yes" style="display: inline;" data-embednum="1"><div id="embedded-1-sh" class="show-hide-div"><button id="embedded-1-toggle" class="show-hide-toggle ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" role="button" aria-disabled="false"><span class="ui-button-text">edit</span></button></div><div id="embedded-1-tabs" class="ui-tabs ui-widget ui-widget-content ui-corner-all" style="display: none;"><div id="embedded-1">
  <ul class="ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all">
    <li class="ui-state-default ui-corner-top ui-tabs-selected ui-state-active"><a href="#embedded-1-2">input</a></li>
    <li class="ui-state-default ui-corner-top"><a href="#embedded-1-3">brat</a></li>
    <li class="ui-state-default ui-corner-top"><a href="#embedded-1-4">info</a></li>
  </ul>
</div><div id="embedded-1-2" class="ui-tabs-panel ui-widget-content ui-corner-bottom"><textarea id="embedded-1-in" class="embedded-brat-data">
# sentence-label A
# visual-style 1	bgColor:blue
# visual-style 1	fgColor:white
# visual-style 2 1 nsubj	color:blue
# visual-style 4 1 nsubj	labelArrow:triangle,10,3
1	(1)	_	VERB	VBZ	fPOS=INTJ++UH	0	ROOT	_	_
2	The	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	3	det	_	_
3	penalty	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	10	nsubjpass	_	_
4	and	_	CONJ	CC	fPOS=CONJ++CC	3	cc	_	_
5	any	_	DET	DT	fPOS=DET++DT	7	det	_	_
6	ancillary	_	ADJ	JJ	Degree=Pos|fPOS=ADJ++JJ	7	amod	_	_
7	measures	_	NOUN	NNS	Number=Plur|fPOS=NOUN++NNS	3	conj	_	_
8	shall	_	AUX	MD	VerbForm=Fin|fPOS=AUX++MD	10	aux	_	_
9	be	_	AUX	VB	VerbForm=Inf|fPOS=AUX++VB	10	auxpass	_	_
10	determined	_	VERB	VBN	Tense=Past|VerbForm=Part|Voice=Pass|fPOS=VERB++VBN	1	nmod	_	_
11	by	_	ADP	IN	fPOS=ADP++IN	13	case	_	_
12	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	13	det	_	_
13	law	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	1	nmod	_	_
14	which	_	PRON	WDT	PronType=Rel|fPOS=PRON++WDT	17	nsubj	_	_
15	is	_	VERB	VBZ	Mood=Ind|Number=Sing|Person=3|Tense=Pres|VerbForm=Fin|fPOS=VERB++VBZ	17	cop	_	_
16	in	_	ADP	IN	fPOS=ADP++IN	17	case	_	_
17	force	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	13	acl:relcl	_	_
18	at	_	ADP	IN	fPOS=ADP++IN	20	case	_	_
19	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	20	det	_	_
20	time	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	17	nmod	_	_
21	of	_	ADP	IN	fPOS=ADP++IN	23	case	_	_
22	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	23	det	_	_
23	act.	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	20	nmod	_	_


# sentence-label B
# visual-style arcs red
# visual-style nodes red
1	buy	buy	VERB	VBP	Num=Plur|Per=3|Tense=Pres	0	root	_	_
2	books	book	NOUN	NNS	Num=Plur	1	dobj	_	_

# sentence-label WIDE LABEL
1	buy	buy	VERB	VBP	Num=Plur|Per=3|Tense=Pres	0	root	_	_
</textarea></div><div id="embedded-1-3" class="ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide"><textarea id="embedded-1-brat" disabled="disabled" class="embedded-brat-data">{
    "entities": [
        [ "embedded-1-S1-T1", "PRON", [ [ 0, 4 ] ] ],
        [ "embedded-1-S1-T2", "VERB", [ [ 5, 8 ] ] ],
        [ "embedded-1-S1-T3", "CONJ", [ [ 9, 12 ] ] ],
        [ "embedded-1-S1-T4", "VERB", [ [ 13, 17 ] ] ],
        [ "embedded-1-S1-T5", "NOUN", [ [ 18, 23 ] ] ],
        [ "embedded-1-S1-T6", "PUNCT", [ [ 24, 25 ] ] ],
        [ "embedded-1-S2-T1", "VERB", [ [ 26, 29 ] ] ],
        [ "embedded-1-S2-T2", "NOUN", [ [ 30, 35 ] ] ],
        [ "embedded-1-S3-T1", "VERB", [ [ 36, 39 ] ] ]
    ],
    "attributes": [ [ "embedded-1-S1-A1", "Case", "embedded-1-S1-T1", 
"Nom" ], [ "embedded-1-S1-A2", "Num", "embedded-1-S1-T1", "Plur" ], [ 
"embedded-1-S1-A3", "Num", "embedded-1-S1-T2", "Plur" ], [ 
"embedded-1-S1-A4", "Per", "embedded-1-S1-T2", "3" ], [ 
"embedded-1-S1-A5", "Tense", "embedded-1-S1-T2", "Pres" ], [ 
"embedded-1-S1-A6", "Num", "embedded-1-S1-T4", "Plur" ], [ 
"embedded-1-S1-A7", "Per", "embedded-1-S1-T4", "3" ], [ 
"embedded-1-S1-A8", "Tense", "embedded-1-S1-T4", "Pres" ], [ 
"embedded-1-S1-A9", "Num", "embedded-1-S1-T5", "Plur" ], [ 
"embedded-1-S2-A1", "Num", "embedded-1-S2-T1", "Plur" ], [ 
"embedded-1-S2-A2", "Per", "embedded-1-S2-T1", "3" ], [ 
"embedded-1-S2-A3", "Tense", "embedded-1-S2-T1", "Pres" ], [ 
"embedded-1-S2-A4", "Num", "embedded-1-S2-T2", "Plur" ], [ 
"embedded-1-S3-A1", "Num", "embedded-1-S3-T1", "Plur" ], [ 
"embedded-1-S3-A2", "Per", "embedded-1-S3-T1", "3" ], [ 
"embedded-1-S3-A3", "Tense", "embedded-1-S3-T1", "Pres" ] ],
    "relations": [
        [ "embedded-1-S1-R0", "nsubj", [ [ "arg1", "embedded-1-S1-T2" ],
 [ "arg2", "embedded-1-S1-T1" ] ] ],
        [ "embedded-1-S1-R1", "nsubj", [ [ "arg1", "embedded-1-S1-T4" ],
 [ "arg2", "embedded-1-S1-T1" ] ] ],
        [ "embedded-1-S1-R2", "root", [ [ "arg1", "embedded-1-S1-T0" ], [
 "arg2", "embedded-1-S1-T2" ] ] ],
        [ "embedded-1-S1-R3", "cc", [ [ "arg1", "embedded-1-S1-T2" ], [ 
"arg2", "embedded-1-S1-T3" ] ] ],
        [ "embedded-1-S1-R4", "conj", [ [ "arg1", "embedded-1-S1-T2" ], [
 "arg2", "embedded-1-S1-T4" ] ] ],
        [ "embedded-1-S1-R5", "dobj", [ [ "arg1", "embedded-1-S1-T2" ], [
 "arg2", "embedded-1-S1-T5" ] ] ],
        [ "embedded-1-S1-R6", "dobj", [ [ "arg1", "embedded-1-S1-T4" ], [
 "arg2", "embedded-1-S1-T5" ] ] ],
        [ "embedded-1-S1-R7", "punct", [ [ "arg1", "embedded-1-S1-T2" ],
 [ "arg2", "embedded-1-S1-T6" ] ] ],
        [ "embedded-1-S2-R0", "root", [ [ "arg1", "embedded-1-S2-T0" ], [
 "arg2", "embedded-1-S2-T1" ] ] ],
        [ "embedded-1-S2-R1", "dobj", [ [ "arg1", "embedded-1-S2-T1" ], [
 "arg2", "embedded-1-S2-T2" ] ] ],
        [ "embedded-1-S3-R0", "root", [ [ "arg1", "embedded-1-S3-T0" ], [
 "arg2", "embedded-1-S3-T1" ] ] ]
    ],
    "comments": [ [ "embedded-1-S1-T1", "AnnotatorNotes", "Lemma: they" 
], [ "embedded-1-S1-T1", "AnnotatorNotes", "Xpostag: PRN" ], [ 
"embedded-1-S1-T2", "AnnotatorNotes", "Lemma: buy" ], [ 
"embedded-1-S1-T2", "AnnotatorNotes", "Xpostag: VBP" ], [ 
"embedded-1-S1-T3", "AnnotatorNotes", "Lemma: and" ], [ 
"embedded-1-S1-T3", "AnnotatorNotes", "Xpostag: CC" ], [ 
"embedded-1-S1-T4", "AnnotatorNotes", "Lemma: sell" ], [ 
"embedded-1-S1-T4", "AnnotatorNotes", "Xpostag: VBP" ], [ 
"embedded-1-S1-T5", "AnnotatorNotes", "Lemma: book" ], [ 
"embedded-1-S1-T5", "AnnotatorNotes", "Xpostag: NNS" ], [ 
"embedded-1-S1-T6", "AnnotatorNotes", "Lemma: ." ], [ 
"embedded-1-S1-T6", "AnnotatorNotes", "Xpostag: ." ], [ 
"embedded-1-S2-T1", "AnnotatorNotes", "Lemma: buy" ], [ 
"embedded-1-S2-T1", "AnnotatorNotes", "Xpostag: VBP" ], [ 
"embedded-1-S2-T2", "AnnotatorNotes", "Lemma: book" ], [ 
"embedded-1-S2-T2", "AnnotatorNotes", "Xpostag: NNS" ], [ 
"embedded-1-S3-T1", "AnnotatorNotes", "Lemma: buy" ], [ 
"embedded-1-S3-T1", "AnnotatorNotes", "Xpostag: VBP" ] ],
    "styles": [ [ "embedded-1-S1-T1", "bgColor", "blue" ], [ 
"embedded-1-S1-T1", "fgColor", "white" ], [ [ "embedded-1-S1-T2", 
"embedded-1-S1-T1", "nsubj" ], "color", "blue" ], [ [ 
"embedded-1-S1-T4", "embedded-1-S1-T1", "nsubj" ], "labelArrow", 
"triangle,10,3" ], [ [ "embedded-1-S2-T0", "embedded-1-S2-T1", "root" ],
 "color", "red" ], [ [ "embedded-1-S2-T1", "embedded-1-S2-T2", "dobj" ],
 "color", "red" ], [ "embedded-1-S2-T1", "bgColor", "red" ], [ 
"embedded-1-S2-T2", "bgColor", "red" ] ],
    "sentlabels": [ "A", "B", "WIDE LABEL" ],
    "text": "They buy and sell books .\nbuy books\nbuy",
    "error": false
}</textarea></div><div id="embedded-1-4" class="ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide"><textarea id="embedded-1-log" disabled="disabled" class="embedded-brat-data">note: TAB found, parsing CoNLL-U in strict mode.
</textarea></div></div><div id="embedded-1-vis" style="display: block; height: 184px;" class="hasSVG"><svg version="1.1" style="width: 800px; height: 184px;"><!-- document: undefined/undefined --><defs><filter id="Gaussian_Blur"><fegaussianblur in="SourceGraphic" stddeviation="2"></fegaussianblur></filter><marker id="drag_arrow" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" class="drag_fill"><polyline points="0,0 5,2.5 0,5 0.2,2.5"></polyline></marker><marker id="arrow_triangle_5_black" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="black"><polyline points="0,0 5,2.5 0,5 0.4166666666666667,2.5"></polyline></marker><marker id="arrow_triangle_3_5_black" refX="3" refY="2.5" markerWidth="3" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="black"><polyline points="0,0 3,2.5 0,5 0.25,2.5"></polyline></marker><marker id="arrow_triangle_5_blue" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="blue"><polyline points="0,0 5,2.5 0,5 0.4166666666666667,2.5"></polyline></marker><marker id="arrow_triangle_3_5_blue" refX="3" refY="2.5" markerWidth="3" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="blue"><polyline points="0,0 3,2.5 0,5 0.25,2.5"></polyline></marker><marker id="arrow_triangle_5_red" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="red"><polyline points="0,0 5,2.5 0,5 0.4166666666666667,2.5"></polyline></marker><marker id="arrow_triangle_3_5_red" refX="3" refY="2.5" markerWidth="3" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="red"><polyline points="0,0 3,2.5 0,5 0.25,2.5"></polyline></marker><marker id="arrow_triangle_10_3_black" refX="10" refY="1.5" markerWidth="10" markerHeight="3" orient="auto" markerUnits="strokeWidth" fill="black"><polyline points="0,0 10,1.5 0,3 0.8333333333333334,1.5"></polyline></marker></defs><g class="background"><rect x="0" y="4" width="800" height="87" class="background0"></rect><rect x="0" y="91" width="800" height="48" class="background1"></rect><rect x="0" y="139" width="800" height="47" class="background0"></rect></g><g class="glow"></g><g class="highlight"><rect x="111.5" y="74" width="29" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="206" y="74" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="270.5" y="74" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="313.5" y="74" width="20" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="388" y="74" width="35" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="452" y="74" width="4" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="114.5" y="122" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="190" y="122" width="35" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="114.5" y="169" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect></g><g class="text"><text x="0" y="0"><tspan x="111.5" y="85" data-chunk-id="0">They </tspan><tspan x="206" y="85" data-chunk-id="1">buy </tspan><tspan x="270.5" y="85" data-chunk-id="2">and </tspan><tspan x="313.5" y="85" data-chunk-id="3">sell </tspan><tspan x="388" y="85" data-chunk-id="4">books </tspan><tspan x="452" y="85" data-chunk-id="5">.
</tspan></text><text x="0" y="0"><tspan x="114.5" y="133" data-chunk-id="6">buy </tspan><tspan x="190" y="133" data-chunk-id="7">books
</tspan></text><text x="0" y="0"><tspan x="114.5" y="180" data-chunk-id="8">buy</tspan></text></g><g transform="translate(0, 85)"><g></g><g transform="translate(111.5, 0)"><g></g><g class="span"><rect x="-7.5" y="-32.5" width="46" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-4.5" y="-29.5" width="40" height="13" class="span_PRON span_default AnnotatorNotes" fill="blue" stroke="#000066" rx="2" ry="1" data-span-id="embedded-1-S1-T1" data-fragment-id="0"></rect><text x="14.5" y="-19" fill="white">PRON<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 14.5,-11.5 14.5,-15.5C14.5,-11.5 29,-15.5 29,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(206, 0)"><g></g><g class="span"><rect x="-10.5" y="-32.5" width="44" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-7.5" y="-29.5" width="38" height="13" class="span_VERB span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S1-T2" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">VERB<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(270.5, 0)"><g></g><g class="span"><rect x="-5.5" y="-32.5" width="33" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-2.5" y="-29.5" width="27" height="13" class="span_CONJ span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S1-T3" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">CONJ</text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(313.5, 0)"><g></g><g class="span"><rect x="-11.5" y="-32.5" width="44" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-8.5" y="-29.5" width="38" height="13" class="span_VERB span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S1-T4" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">VERB<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 20,-15.5 20,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(388, 0)"><g></g><g class="span"><rect x="-5.5" y="-32.5" width="47" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-2.5" y="-29.5" width="41" height="13" class="span_NOUN span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S1-T5" data-fragment-id="0"></rect><text x="17.5" y="-19" fill="#000000">NOUN<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 17.5,-11.5 17.5,-15.5C17.5,-11.5 35,-15.5 35,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(452, 0)"><g></g><g class="span"><rect x="-18.5" y="-32.5" width="42" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-15.5" y="-29.5" width="36" height="13" class="span_PUNCT span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S1-T6" data-fragment-id="0"></rect><text x="2.5" y="-19" fill="#000000">PUNCT</text><path d="M0,-11.5C0,-15.5 2.5,-11.5 2.5,-15.5C2.5,-11.5 4,-15.5 4,-11.5" class="curly" stroke="#000000"></path></g></g><g class="arcs"><g data-from="embedded-1-S1-T2" data-to="embedded-1-S1-T3"><text x="252.25" y="-25.25" fill="black" data-arc-role="cc" data-arc-origin="embedded-1-S1-T2" data-arc-target="embedded-1-S1-T3" data-arc-ed="embedded-1-S1-R3">cc</text><path d="M246.25,-28.5L245.25,-28.5Q240.875,-28.5 236.5,-23" style="stroke: black"></path><path d="M261.25,-28.5L262.25,-28.5Q265.125,-28.5 268,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g><g data-from="embedded-1-S1-T2" data-to="embedded-1-S1-T1"><text x="172.75" y="-25.25" fill="blue" data-arc-role="nsubj" data-arc-origin="embedded-1-S1-T2" data-arc-target="embedded-1-S1-T1" data-arc-ed="embedded-1-S1-R0">nsubj</text><path d="M156.25,-28.5L155.25,-28.5Q151.125,-28.5 147,-28.5" marker-end="url(#arrow_triangle_5_blue)" marker-start="url(#arrow_triangle_3_5_blue)" style="stroke: blue"></path><path d="M186.25,-28.5L187.25,-28.5Q192.875,-28.5 198.5,-23" style="stroke: blue"></path></g><g data-from="embedded-1-S1-T4" data-to="embedded-1-S1-T5"><text x="364.25" y="-25.25" fill="black" data-arc-role="dobj" data-arc-origin="embedded-1-S1-T4" data-arc-target="embedded-1-S1-T5" data-arc-ed="embedded-1-S1-R6">dobj</text><path d="M352.75,-28.5L351.75,-28.5Q347.375,-28.5 343,-23" style="stroke: black"></path><path d="M378.75,-28.5L379.75,-28.5Q382.625,-28.5 385.5,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g><g data-from="embedded-1-S1-T2" data-to="embedded-1-S1-T4"><text x="270.75" y="-37.25" fill="black" data-arc-role="conj" data-arc-origin="embedded-1-S1-T2" data-arc-target="embedded-1-S1-T4" data-arc-ed="embedded-1-S1-R4">conj</text><path d="M259.75,-40.5L251.5,-40.5Q244,-40.5 236.5,-23" style="stroke: black"></path><path d="M284.75,-40.5L290,-40.5Q297.5,-40.5 305,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g><g data-from="embedded-1-S1-T4" data-to="embedded-1-S1-T1"><text x="226" y="-46.25" fill="black" data-arc-role="nsubj" data-arc-origin="embedded-1-S1-T4" data-arc-target="embedded-1-S1-T1" data-arc-ed="embedded-1-S1-R1">nsubj</text><path d="M202.5,-49.5L162,-49.5Q154.5,-49.5 147,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_10_3_black)" style="stroke: black"></path><path d="M239.5,-49.5L290,-49.5Q297.5,-49.5 305,-23" style="stroke: black"></path></g><g data-from="embedded-1-S1-T2" data-to="embedded-1-S1-T5"><text x="311" y="-55.25" fill="black" data-arc-role="dobj" data-arc-origin="embedded-1-S1-T2" data-arc-target="embedded-1-S1-T5" data-arc-ed="embedded-1-S1-R5">dobj</text><path d="M299.5,-58.5L251.5,-58.5Q244,-58.5 236.5,-23" style="stroke: black"></path><path d="M325.5,-58.5L370.5,-58.5Q378,-58.5 385.5,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g><g data-from="embedded-1-S1-T2" data-to="embedded-1-S1-T6" class=""><text x="336.5" y="-64.25" fill="black" data-arc-role="punct" data-arc-origin="embedded-1-S1-T2" data-arc-target="embedded-1-S1-T6" data-arc-ed="embedded-1-S1-R7" class="">punct</text><path d="M322,-67.5L251.5,-67.5Q244,-67.5 236.5,-23" style="stroke: black"></path><path d="M354,-67.5L421.5,-67.5Q429,-67.5 436.5,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g></g></g><g transform="translate(0, 133)"><g></g><g transform="translate(114.5, 0)"><g></g><g class="span"><rect x="-10.5" y="-32.5" width="44" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-7.5" y="-29.5" width="38" height="13" class="span_VERB span_default AnnotatorNotes" fill="red" stroke="#660000" rx="2" ry="1" data-span-id="embedded-1-S2-T1" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">VERB<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(190, 0)"><g></g><g class="span"><rect x="-5.5" y="-32.5" width="47" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-2.5" y="-29.5" width="41" height="13" class="span_NOUN span_default AnnotatorNotes" fill="red" stroke="#660000" rx="2" ry="1" data-span-id="embedded-1-S2-T2" data-fragment-id="0"></rect><text x="17.5" y="-19" fill="#000000">NOUN<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 17.5,-11.5 17.5,-15.5C17.5,-11.5 35,-15.5 35,-11.5" class="curly" stroke="#000000"></path></g></g><g class="arcs"><g data-from="embedded-1-S2-T1" data-to="embedded-1-S2-T2"><text x="166.25" y="-25.25" fill="red" data-arc-role="dobj" data-arc-origin="embedded-1-S2-T1" data-arc-target="embedded-1-S2-T2" data-arc-ed="embedded-1-S2-R1">dobj</text><path d="M154.75,-28.5L153.75,-28.5Q149.375,-28.5 145,-23" style="stroke: red"></path><path d="M180.75,-28.5L181.75,-28.5Q184.625,-28.5 187.5,-28.5" marker-end="url(#arrow_triangle_5_red)" marker-start="url(#arrow_triangle_3_5_red)" style="stroke: red"></path></g></g></g><g transform="translate(0, 180)"><g></g><g transform="translate(114.5, 0)"><g></g><g class="span"><rect x="-10.5" y="-32.5" width="44" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-7.5" y="-29.5" width="38" height="13" class="span_VERB span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-1-S3-T1" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">VERB<tspan class="glyph attribute_warning">#</tspan></text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g class="arcs"></g></g><path marker-end="url(#drag_arrow)" class="drag_stroke" fill="none" visibility="hidden"></path><g class="sentnum"><a xlink:href="#undefined?focus=sent~1"><text x="98" y="85" data-sent="1" style="display: inline;">A</text></a><a xlink:href="#undefined?focus=sent~2"><text x="98" y="133" data-sent="2" style="display: inline;">B</text></a><a xlink:href="#undefined?focus=sent~3"><text x="98" y="180" data-sent="3" style="display: inline;">WIDE LABEL</text></a><path d="M100,0L100,184" style="display: inline;"></path></g></svg></div></code>

<p>Here are some more tests:
<a href="http://spyysalo.github.io/conllu.js/tests.html">tests.html</a></p>

<p>Here's a validating visualizer. Visualization:</p>
<div id="vis" style="display: block; height: 50px;" class="hasSVG"><svg version="1.1" style="width: 800px; height: 50px;"><!-- document: undefined/undefined --><defs><filter id="Gaussian_Blur"><fegaussianblur in="SourceGraphic" stddeviation="2"></fegaussianblur></filter><marker id="drag_arrow" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" class="drag_fill"><polyline points="0,0 5,2.5 0,5 0.2,2.5"></polyline></marker><marker id="arrow_triangle_5_black" refX="5" refY="2.5" markerWidth="5" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="black"><polyline points="0,0 5,2.5 0,5 0.4166666666666667,2.5"></polyline></marker><marker id="arrow_triangle_3_5_black" refX="3" refY="2.5" markerWidth="3" markerHeight="5" orient="auto" markerUnits="strokeWidth" fill="black"><polyline points="0,0 3,2.5 0,5 0.25,2.5"></polyline></marker></defs><g class="background"><rect x="0" y="4" width="800" height="48" class="background0"></rect></g><g class="glow"></g><g class="highlight"><rect x="30.5" y="35" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect><rect x="105" y="35" width="21" height="14" fill="#e5ecfe" rx="3" ry="3"></rect></g><g class="text"><text x="0" y="0"><tspan x="30.5" y="46" data-chunk-id="0">edit </tspan><tspan x="105" y="46" data-chunk-id="1">this</tspan></text></g><g transform="translate(0, 46)"><g></g><g transform="translate(30.5, 0)"><g></g><g class="span"><rect x="-6.5" y="-32.5" width="35" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-3.5" y="-29.5" width="29" height="13" class="span_VERB span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-2-S1-T1" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">VERB</text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g transform="translate(105, 0)"><g></g><g class="span"><rect x="-7.5" y="-32.5" width="38" height="19" class="shadow_AnnotatorNotes" filter="url(#Gaussian_Blur)" rx="2.5" ry="2.5"></rect><rect x="-4.5" y="-29.5" width="32" height="13" class="span_NOUN span_default AnnotatorNotes" fill="#7fa2ff" stroke="#002998" rx="2" ry="1" data-span-id="embedded-2-S1-T2" data-fragment-id="0"></rect><text x="10.5" y="-19" fill="#000000">NOUN</text><path d="M0,-11.5C0,-15.5 10.5,-11.5 10.5,-15.5C10.5,-11.5 21,-15.5 21,-11.5" class="curly" stroke="#000000"></path></g></g><g class="arcs"><g data-from="embedded-2-S1-T1" data-to="embedded-2-S1-T2"><text x="78.25" y="-25.25" fill="black" data-arc-role="dobj" data-arc-origin="embedded-2-S1-T1" data-arc-target="embedded-2-S1-T2" data-arc-ed="embedded-2-S1-R1">dobj</text><path d="M66.75,-28.5L65.75,-28.5Q60.875,-28.5 56,-23" style="stroke: black"></path><path d="M92.75,-28.5L93.75,-28.5Q97.125,-28.5 100.5,-28.5" marker-end="url(#arrow_triangle_5_black)" marker-start="url(#arrow_triangle_3_5_black)" style="stroke: black"></path></g></g></g><path marker-end="url(#drag_arrow)" class="drag_stroke" fill="none" visibility="hidden"></path><g class="sentnum"><a xlink:href="#undefined?focus=sent~1"><text x="18" y="46" data-sent="1" style="display: inline;">2</text></a><path d="M20,0L20,50" style="display: inline;"></path></g></svg></div>

<p> Input (editable):</p>
<textarea id="input" rows="10" cols="80" style="margin-top:0">1	(1)	_	VERB	VBZ	fPOS=INTJ++UH	0	ROOT	_	_
2	The	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	3	det	_	_
3	penalty	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	10	nsubjpass	_	_
4	and	_	CONJ	CC	fPOS=CONJ++CC	3	cc	_	_
5	any	_	DET	DT	fPOS=DET++DT	7	det	_	_
6	ancillary	_	ADJ	JJ	Degree=Pos|fPOS=ADJ++JJ	7	amod	_	_
7	measures	_	NOUN	NNS	Number=Plur|fPOS=NOUN++NNS	3	conj	_	_
8	shall	_	AUX	MD	VerbForm=Fin|fPOS=AUX++MD	10	aux	_	_
9	be	_	AUX	VB	VerbForm=Inf|fPOS=AUX++VB	10	auxpass	_	_
10	determined	_	VERB	VBN	Tense=Past|VerbForm=Part|Voice=Pass|fPOS=VERB++VBN	1	nmod	_	_
11	by	_	ADP	IN	fPOS=ADP++IN	13	case	_	_
12	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	13	det	_	_
13	law	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	1	nmod	_	_
14	which	_	PRON	WDT	PronType=Rel|fPOS=PRON++WDT	17	nsubj	_	_
15	is	_	VERB	VBZ	Mood=Ind|Number=Sing|Person=3|Tense=Pres|VerbForm=Fin|fPOS=VERB++VBZ	17	cop	_	_
16	in	_	ADP	IN	fPOS=ADP++IN	17	case	_	_
17	force	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	13	acl:relcl	_	_
18	at	_	ADP	IN	fPOS=ADP++IN	20	case	_	_
19	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	20	det	_	_
20	time	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	17	nmod	_	_
21	of	_	ADP	IN	fPOS=ADP++IN	23	case	_	_
22	the	_	DET	DT	Definite=Def|PronType=Art|fPOS=DET++DT	23	det	_	_
23	act.	_	NOUN	NN	Number=Sing|fPOS=NOUN++NN	20	nmod	_	_

</textarea>

<p>Log and validator output:</p>
<textarea id="log" rows="10" cols="80" style="margin-top:0" disabled="disabled">note:
 TAB found, parsing CoNLL-U in strict mode.
error: line 1: invalid FEATS entry: "fPOS=INTJ++UH" ("1	(1)	_	VERB	VBZ	
fPOS=INTJ++UH	0	ROOT	_	_")
repair: blanking invalid FEATS
error: line 2: invalid FEATS entry: "fPOS=DET++DT" ("2	The	_	DET	DT	
Definite=Def|PronType=Art|fPOS=DET++DT	3	det	_	_")
repair: blanking invalid FEATS
error: line 3: invalid FEATS entry: "fPOS=NOUN++NN" ("3	penalty	_	NOUN	
NN	Number=Sing|fPOS=NOUN++NN	10	nsubjpass	_	_")
repair: blanking invalid FEATS
error: line 4: invalid FEATS entry: "fPOS=CONJ++CC" ("4	and	_	CONJ	CC	
fPOS=CONJ++CC	3	cc	_	_")
repair: blanking invalid FEATS
error: line 5: invalid FEATS entry: "fPOS=DET++DT" ("5	any	_	DET	DT	
fPOS=DET++DT	7	det	_	_")
repair: blanking invalid FEATS
error: line 6: invalid FEATS entry: "fPOS=ADJ++JJ" ("6	ancillary	_	ADJ	
JJ	Degree=Pos|fPOS=ADJ++JJ	7	amod	_	_")
repair: blanking invalid FEATS
error: line 7: invalid FEATS entry: "fPOS=NOUN++NNS" ("7	measures	_	NOUN
	NNS	Number=Plur|fPOS=NOUN++NNS	3	conj	_	_")
repair: blanking invalid FEATS
error: line 8: invalid FEATS entry: "fPOS=AUX++MD" ("8	shall	_	AUX	MD	
VerbForm=Fin|fPOS=AUX++MD	10	aux	_	_")
repair: blanking invalid FEATS
error: line 9: invalid FEATS entry: "fPOS=AUX++VB" ("9	be	_	AUX	VB	
VerbForm=Inf|fPOS=AUX++VB	10	auxpass	_	_")
repair: blanking invalid FEATS
error: line 10: invalid FEATS entry: "fPOS=VERB++VBN" ("10	determined	_	
VERB	VBN	Tense=Past|VerbForm=Part|Voice=Pass|fPOS=VERB++VBN	1	nmod	_	_")
repair: blanking invalid FEATS
error: line 11: invalid FEATS entry: "fPOS=ADP++IN" ("11	by	_	ADP	IN	
fPOS=ADP++IN	13	case	_	_")
repair: blanking invalid FEATS
error: line 12: invalid FEATS entry: "fPOS=DET++DT" ("12	the	_	DET	DT	
Definite=Def|PronType=Art|fPOS=DET++DT	13	det	_	_")
repair: blanking invalid FEATS
error: line 13: invalid FEATS entry: "fPOS=NOUN++NN" ("13	law	_	NOUN	NN	
Number=Sing|fPOS=NOUN++NN	1	nmod	_	_")
repair: blanking invalid FEATS
error: line 14: invalid FEATS entry: "fPOS=PRON++WDT" ("14	which	_	PRON	
WDT	PronType=Rel|fPOS=PRON++WDT	17	nsubj	_	_")
repair: blanking invalid FEATS
error: line 15: invalid FEATS entry: "fPOS=VERB++VBZ" ("15	is	_	VERB	VBZ
	Mood=Ind|Number=Sing|Person=3|Tense=Pres|VerbForm=Fin|fPOS=VERB++VBZ	17
	cop	_	_")
repair: blanking invalid FEATS
error: line 16: invalid FEATS entry: "fPOS=ADP++IN" ("16	in	_	ADP	IN	
fPOS=ADP++IN	17	case	_	_")
repair: blanking invalid FEATS
error: line 17: invalid FEATS entry: "fPOS=NOUN++NN" ("17	force	_	NOUN	
NN	Number=Sing|fPOS=NOUN++NN	13	acl:relcl	_	_")
repair: blanking invalid FEATS
error: line 18: invalid FEATS entry: "fPOS=ADP++IN" ("18	at	_	ADP	IN	
fPOS=ADP++IN	20	case	_	_")
repair: blanking invalid FEATS
error: line 19: invalid FEATS entry: "fPOS=DET++DT" ("19	the	_	DET	DT	
Definite=Def|PronType=Art|fPOS=DET++DT	20	det	_	_")
repair: blanking invalid FEATS
error: line 20: invalid FEATS entry: "fPOS=NOUN++NN" ("20	time	_	NOUN	NN
	Number=Sing|fPOS=NOUN++NN	17	nmod	_	_")
repair: blanking invalid FEATS
error: line 21: invalid FEATS entry: "fPOS=ADP++IN" ("21	of	_	ADP	IN	
fPOS=ADP++IN	23	case	_	_")
repair: blanking invalid FEATS
error: line 22: invalid FEATS entry: "fPOS=DET++DT" ("22	the	_	DET	DT	
Definite=Def|PronType=Art|fPOS=DET++DT	23	det	_	_")
repair: blanking invalid FEATS
error: line 23: invalid FEATS entry: "fPOS=NOUN++NN" ("23	act.	_	NOUN	NN
	Number=Sing|fPOS=NOUN++NN	20	nmod	_	_")
repair: blanking invalid FEATS
error: line 25: empty sentence, ignoring ("")
note: TAB found, parsing CoNLL-U in strict mode.
note: TAB found, parsing CoNLL-U in strict mode.
</textarea>

<!-- no need to show the intermediate data representation -->
<textarea id="parsed" style="display:none; margin: 0">{
    "entities": [
        [ "embedded-2-S1-T1", "VERB", [ [ 0, 4 ] ] ],
        [ "embedded-2-S1-T2", "NOUN", [ [ 5, 9 ] ] ]
    ],
    "attributes": [],
    "relations": [
        [ "embedded-2-S1-R0", "root", [ [ "arg1", "embedded-2-S1-T0" ], [
 "arg2", "embedded-2-S1-T1" ] ] ],
        [ "embedded-2-S1-R1", "dobj", [ [ "arg1", "embedded-2-S1-T1" ], [
 "arg2", "embedded-2-S1-T2" ] ] ]
    ],
    "comments": [ [ "embedded-2-S1-T1", "AnnotatorNotes", "Lemma: edit" 
], [ "embedded-2-S1-T1", "AnnotatorNotes", "Xpostag: VERB" ], [ 
"embedded-2-S1-T2", "AnnotatorNotes", "Lemma: this" ], [ 
"embedded-2-S1-T2", "AnnotatorNotes", "Xpostag: NOUN" ] ],
    "styles": [],
    "sentlabels": [ "2" ],
    "text": "edit this",
    "error": false
}</textarea>

<!-- this div just initializes the pre-built visualization above. -->
<div class="conllu-parse embedding embedded-wrapper" data-visid="vis" data-inputid="input" data-parsedid="parsed" data-logid="log" style="display: block;" data-embednum="2"></div>


<p>Also, please see
<a href="http://universaldependencies.github.io/docs/">Universal
Dependencies</a> for an example of a project using the library.</p>

</article>

      </div>
    </div>
  </div>



<script type="text/javascript">
    var root = ''; // filled in by jekyll
    head.js(
        // External libraries
        root + 'lib/ext/jquery.min.js',
        root + 'lib/ext/jquery.svg.min.js',
        root + 'lib/ext/jquery.svgdom.min.js',
        root + 'lib/ext/jquery-ui.min.js',
        root + 'lib/ext/waypoints.min.js',

        // brat helper modules
        root + 'lib/brat/configuration.js',
        root + 'lib/brat/util.js',
        root + 'lib/brat/annotation_log.js',
        root + 'lib/ext/webfont.js',
        // brat modules
        root + 'lib/brat/dispatcher.js',
        root + 'lib/brat/url_monitor.js',
        root + 'lib/brat/visualizer.js',

        // annotation documentation support
        'http://spyysalo.github.io/annodoc/lib/local/annodoc.js',
        root + 'lib/local/config.js',

        // the conllu.js library itself
        root + 'conllu.js'
    );

    var webFontURLs = [
        root + 'static/fonts/PT_Sans-Caption-Web-Regular.ttf',
        root + 'static/fonts/Liberation_Sans-Regular.ttf'
    ];

    /* not used here */
    var documentCollections = {};

    head.ready(function() {
	// performes all embedding and support functions
	Annodoc.activate(Config.bratCollData, documentCollections);
    });
</script>


<div id="commentpopup" style="left: 809px; top: 267px;"><span class="comment_type_id_wrapper"><span class="comment_type">punct</span></span></div></body><script type="text/javascript" src="conllu.js_files/jquery.js"></script><script type="text/javascript" src="conllu.js_files/jquery_002.js"></script><script type="text/javascript" src="conllu.js_files/jquery_003.js"></script><script type="text/javascript" src="conllu.js_files/jquery-ui.js"></script><script type="text/javascript" src="conllu.js_files/waypoints.js"></script><script type="text/javascript" src="conllu.js_files/configuration.js"></script><script type="text/javascript" src="conllu.js_files/util.js"></script><script type="text/javascript" src="conllu.js_files/annotation_log.js"></script><script type="text/javascript" src="conllu.js_files/webfont.js"></script><script type="text/javascript" src="conllu.js_files/dispatcher.js"></script><script type="text/javascript" src="conllu.js_files/url_monitor.js"></script><script type="text/javascript" src="conllu.js_files/visualizer.js"></script><script type="text/javascript" src="conllu.js_files/annodoc.js"></script><script type="text/javascript" src="conllu.js_files/config.js"></script><script type="text/javascript" src="conllu.js_files/conllu.js"></script></html>
